import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


public class ErrorMessage extends JDialog implements ActionListener {
    
    Container cp = getContentPane();
    private JButton btOK;

    ErrorMessage(JFrame owner, String message){
	super(owner,"Error!!!",true);
	String printedMessage = printed(message);
	JTextArea ta;
	setLocation(getParent().getX()+80,getParent().getY()+60);
	setSize(600,600);
	setResizable(false);
	cp.setBackground(SystemColor.controlHighlight);
	cp.setLayout(new BorderLayout(2,1));
	cp.add(ta = new JTextArea(printedMessage),"North");
	ta.setFont(new Font("Monospaced",Font.PLAIN,10));
	ta.setEnabled(false);
	ta.setCaretPosition(0);
	//System.out.println(message);
	//	cp.add(new JLabel("Can I see this???"));
	JPanel panel = new JPanel();
	btOK = new JButton("OK");
	panel.add(btOK);
	cp.add(panel);
	btOK.addActionListener(this);
	pack();
	show();
    }

    public void actionPerformed(ActionEvent e){
	dispose();
    }

    String printed(String message){
	String p = "";
	int curpos = 0;
	int nextpos = curpos;
	int prevpos = nextpos;
	while(curpos < message.length()){
	    while((nextpos = nextWhiteSpace(message,prevpos)) < message.length() && nextpos - curpos < 50){
		prevpos = nextpos + 1;
	    }
	    if(nextpos < message.length()){
		if(curpos != prevpos){
		    p += message.substring(curpos,prevpos)+'\n';
		    curpos = prevpos;
		}
		else{
		    p += message.substring(curpos,nextpos)+'\n';
		    curpos = nextpos;
		}
	    }
	    else{
		if(nextpos - curpos < 50){
		    p += message.substring(curpos,nextpos)+'\n';
		    curpos = nextpos+1;		
		}
		else{		    
		    p += message.substring(curpos,prevpos)+'\n'+message.substring(prevpos,nextpos);
		    curpos = nextpos+1;		
		}
	    }
	}
	//	System.out.println(p);
	return p;
    }

    int nextWhiteSpace(String m, int curpos){
	int i = curpos;
	while(i < m.length() && m.charAt(i) != ' ' && m.charAt(i) != '\t' && m.charAt(i) != '\n'){
	    i++;
	}
	return i;
    }

}
